KDateTable Class Reference

`#include <kdatetbl.h>`

Inherits QGridView.

## Public Types

enum | BackgroundMode { NoBgMode =0, RectangleMode, CircleMode }

## Signals

void | dateChanged (QDate)
void | dateChanged (const QDate &cur, const QDate &old)
void | tableClicked ()
void | aboutToShowContextMenu (KPopupMenu *menu, const QDate &date)

## Public Member Functions

| KDateTable (QWidget *parent=0, QDate date=QDate::currentDate(), const char *name=0, WFlags f=0)
| KDateTable (QWidget *parent, const char *name, WFlags f=0)
| ~KDateTable ()
virtual QSize | sizeHint () const
void | setFontSize (int size)
bool | setDate (const QDate &)
const QDate & | getDate () const
void | setPopupMenuEnabled (bool enable)
bool | popupMenuEnabled () const
void | setCustomDatePainting (const QDate &date, const QColor &fgColor, BackgroundMode bgMode=NoBgMode, const QColor &bgColor=QColor())
void | unsetCustomDatePainting (const QDate &date)

## Protected Member Functions

int | posFromDate (const QDate &date)
QDate | dateFromPos (int pos)
virtual void | paintCell (QPainter *, int, int)
virtual void | paintEmptyArea (QPainter *, int, int, int, int)
virtual void | viewportResizeEvent (QResizeEvent *)
virtual void | contentsMousePressEvent (QMouseEvent *)
virtual void | wheelEvent (QWheelEvent *e)
virtual void | keyPressEvent (QKeyEvent *e)
virtual void | focusInEvent (QFocusEvent *e)
virtual void | focusOutEvent (QFocusEvent *e)
virtual void | virtual_hook (int id, void *data)

## Protected Attributes

int | fontsize
int | firstday
int | numdays
int | numDaysPrevMonth
bool | unused_hasSelection
QRect | maxCell

## Properties

QDate | date
bool | popupMenu

## Detailed Description

Date selection table.

This is a support class for the KDatePicker class. It just draws the calender table without titles, but could theoretically be used as a standalone.

When a date is selected by the user, it emits a signal: dateSelected(QDate)

Version

Id
  kdatetbl.h 565029 2006-07-22 07:30:24Z kling

Author
  Tim Gilman, Mirko Boehm

Definition at line 263 of file kdatetbl.h.

## Constructor & Destructor Documentation

KDateTable::KDateTable | ( | QWidget * | parent = `0`,
|  | QDate | date = `QDate::currentDate()`,
|  | const char * | name = `0`,
|  | WFlags | f = `0`
| ) |  |

The constructor.

Definition at line 116 of file kdatetbl.cpp.

KDateTable::KDateTable | ( | QWidget * | parent,
|  | const char * | name,
|  | WFlags | f = `0`
| ) |  |

The constructor.

Since
  3.4

Definition at line 137 of file kdatetbl.cpp.

KDateTable::~KDateTable | ( |  | ) |

The destructor.

Definition at line 152 of file kdatetbl.cpp.

## Member Function Documentation

void KDateTable::aboutToShowContextMenu | ( | KPopupMenu * | menu,
|  | const QDate & | date
| ) |  |

signal

A popup menu for a given date is about to be shown (as when the user right clicks on that date and the popup menu is enabled).

Connect the slot where you fill the menu to this signal.

Since
  3.2

void KDateTable::contentsMousePressEvent | ( | QMouseEvent * | e | ) |

protected virtual

React on mouse clicks that select a date.

Definition at line 454 of file kdatetbl.cpp.

void KDateTable::dateChanged | ( | QDate |  | ) |

signal

The selected date changed.

void KDateTable::dateChanged | ( | const QDate & | cur,
|  | const QDate & | old
| ) |  |

signal

This function behaves essentially like the one above.

The selected date changed.

Parameters

  cur | The current date
  old | The date before the date was changed

QDate KDateTable::dateFromPos | ( | int | pos | ) |

protected

calculate the date that is displayed at a given cell in the matrix.

pos is the 0-based index in the matrix. Inverse function to posForDate().

Definition at line 181 of file kdatetbl.cpp.

void KDateTable::paintCell | ( | QPainter * | painter,
|  | int | row,
|  | int | col
| ) |  |

protected virtual

Paint a cell.

Definition at line 211 of file kdatetbl.cpp.

void KDateTable::paintEmptyArea | ( | QPainter * | paint,
|  | int | ,
|  | int | ,
|  | int | ,
|  | int |
| ) |  |

protected virtual

Paint the empty area (background).

Definition at line 197 of file kdatetbl.cpp.

bool KDateTable::popupMenuEnabled | ( |  | ) | const

Returns if the popup menu is enabled or not.

Definition at line 580 of file kdatetbl.cpp.

int KDateTable::posFromDate | ( | const QDate & | date | ) |

protected

calculate the position of the cell in the matrix for the given date.

The result is the 0-based index.

Definition at line 169 of file kdatetbl.cpp.

void KDateTable::setCustomDatePainting | ( | const QDate & | date,
|  | const QColor & | fgColor,
|  | BackgroundMode | bgMode = `NoBgMode`,
|  | const QColor & | bgColor = `QColor()`
| ) |  |

Makes a given date be painted with a given foregroundColor, and background (a rectangle, or a circle/ellipse) in a given color.

Since
  3.2

Definition at line 585 of file kdatetbl.cpp.

bool KDateTable::setDate | ( | const QDate & | date_ | ) |

Select and display this date.

Definition at line 509 of file kdatetbl.cpp.

void KDateTable::setFontSize | ( | int | size | ) |

Set the font size of the date table.

Definition at line 423 of file kdatetbl.cpp.

void KDateTable::setPopupMenuEnabled | ( | bool | enable | ) |

Enables a popup menu when right clicking on a date.

When it's enabled, this object emits a aboutToShowContextMenu signal where you can fill in the menu items.

Since
  3.2

Definition at line 575 of file kdatetbl.cpp.

QSize KDateTable::sizeHint | ( | void |  | ) | const

virtual

Returns a recommended size for the widget.

To save some time, the size of the largest used cell content is calculated in each paintCell() call, since all calculations have to be done there anyway. The size is stored in maxCell. The sizeHint() simply returns a multiple of maxCell.

Definition at line 563 of file kdatetbl.cpp.

void KDateTable::tableClicked | ( |  | ) |

signal

A date has been selected by clicking on the table.

void KDateTable::unsetCustomDatePainting | ( | const QDate & | date | ) |

Unsets the custom painting of a date so that the date is painted as usual.

Since
  3.2

Definition at line 603 of file kdatetbl.cpp.

void KDateTable::viewportResizeEvent | ( | QResizeEvent * | e | ) |

protected virtual

Handle the resize events.

Definition at line 414 of file kdatetbl.cpp.

## Member Data Documentation

int KDateTable::firstday

protected

The day of the first day in the month [1..7].

Definition at line 385 of file kdatetbl.h.

int KDateTable::fontsize

protected

The font size of the displayed text.

Definition at line 377 of file kdatetbl.h.

QRect KDateTable::maxCell

protected

Save the size of the largest used cell content.

Definition at line 402 of file kdatetbl.h.

int KDateTable::numdays

protected

The number of days in the current month.

Definition at line 389 of file kdatetbl.h.

int KDateTable::numDaysPrevMonth

protected

The number of days in the previous month.

Definition at line 393 of file kdatetbl.h.

bool KDateTable::unused_hasSelection

protected

unused

### remove in KDE 4.0

Definition at line 398 of file kdatetbl.h.

## Property Documentation

QDate KDateTable::date

read write

The currently selected date.

Definition at line 266 of file kdatetbl.h.

The documentation for this class was generated from the following files:

- kdatetbl.h
- kdatetbl.cpp

KDE Home | KDE Accessibility Home | Description of Access Keys